use std::path::PathBuf;

use deimos::ast::build::build_ast;

pub fn dump_ast(path: &PathBuf) {
    let src = std::fs::read_to_string(path).expect(&format!("Could not read {:?}", path));
    let ast = build_ast(&src);
    println!("{:?}", ast);
}
